diff --git a/external/fmt/test/fuzzing/fuzzer-common.h b/external/fmt/test/fuzzing/fuzzer-common.h
new file mode 100644
index 00000000..c0a24672
--- /dev/null
+++ b/external/fmt/test/fuzzing/fuzzer-common.h
@@ -0,0 +1,77 @@
+// Copyright (c) 2019, Paul Dreik
+// For the license information refer to format.h.
+
+#ifndef FUZZER_COMMON_H
+#define FUZZER_COMMON_H
+
+#include <fmt/core.h>
+
+#include <cstdint>  // std::uint8_t
+#include <cstring>  // memcpy
+#include <vector>
+
+// One can format to either a string, or a buffer. The latter is faster, but
+// one may be interested in formatting to a string instead to verify it works
+// as intended. To avoid a combinatoric explosion, select this at compile time
+// instead of dynamically from the fuzz data.
+#define FMT_FUZZ_FORMAT_TO_STRING 0
+
+// If {fmt} is given a buffer that is separately allocated, chances that address
+// sanitizer detects out of bound reads is much higher. However, it slows down
+// the fuzzing.
+#define FMT_FUZZ_SEPARATE_ALLOCATION 1
+
+// The size of the largest possible type in use.
+// To let the the fuzzer mutation be efficient at cross pollinating between
+// different types, use a fixed size format. The same bit pattern, interpreted
+// as another type, is likely interesting.
+constexpr auto fixed_size = 16;
+
+// Casts data to a char pointer.
+template <typename T> inline const char* as_chars(const T* data) {
+  return reinterpret_cast<const char*>(data);
+}
+
+// Casts data to a byte pointer.
+template <typename T> inline const std::uint8_t* as_bytes(const T* data) {
+  return reinterpret_cast<const std::uint8_t*>(data);
+}
+
+// Blits bytes from data to form an (assumed trivially constructible) object
+// of type Item.
+template <class Item> inline Item assign_from_buf(const std::uint8_t* data) {
+  auto item = Item();
+  std::memcpy(&item, data, sizeof(Item));
+  return item;
+}
+
+// Reads a boolean value by looking at the first byte from data.
+template <> inline bool assign_from_buf<bool>(const std::uint8_t* data) {
+  return *data != 0;
+}
+
+struct data_to_string {
+#if FMT_FUZZ_SEPARATE_ALLOCATION
+  std::vector<char> buffer;
+
+  data_to_string(const uint8_t* data, size_t size, bool add_terminator = false)
+      : buffer(size + (add_terminator ? 1 : 0)) {
+    if (size) {
+      std::memcpy(buffer.data(), data, size);
+    }
+  }
+
+  fmt::string_view get() const { return {buffer.data(), buffer.size()}; }
+#else
+  fmt::string_view sv;
+
+  data_to_string(const uint8_t* data, size_t size, bool = false)
+      : str(as_chars(data), size) {}
+
+  fmt::string_view get() const { return sv; }
+#endif
+
+  const char* data() const { return get().data(); }
+};
+
+#endif  // FUZZER_COMMON_H
diff --git a/external/fmt/test/fuzzing/main.cc b/external/fmt/test/fuzzing/main.cc
new file mode 100644
index 00000000..8f8c719b
--- /dev/null
+++ b/external/fmt/test/fuzzing/main.cc
@@ -0,0 +1,22 @@
+#include <cassert>
+#include <fstream>
+#include <vector>
+
+#include "fuzzer-common.h"
+
+extern "C" int LLVMFuzzerTestOneInput(const uint8_t* data, size_t size);
+
+int main(int argc, char** argv) {
+  for (int i = 1; i < argc; ++i) {
+    std::ifstream in(argv[i]);
+    assert(in);
+    in.seekg(0, std::ios_base::end);
+    const auto size = in.tellg();
+    assert(size >= 0);
+    in.seekg(0, std::ios_base::beg);
+    std::vector<char> buf(static_cast<size_t>(size));
+    in.read(buf.data(), size);
+    assert(in.gcount() == size);
+    LLVMFuzzerTestOneInput(as_bytes(buf.data()), buf.size());
+  }
+}
diff --git a/external/fmt/test/fuzzing/named-arg.cc b/external/fmt/test/fuzzing/named-arg.cc
new file mode 100644
index 00000000..3bee1ae3
--- /dev/null
+++ b/external/fmt/test/fuzzing/named-arg.cc
@@ -0,0 +1,102 @@
+// Copyright (c) 2019, Paul Dreik
+// For the license information refer to format.h.
+
+#include <fmt/chrono.h>
+
+#include <cstdint>
+#include <type_traits>
+#include <vector>
+
+#include "fuzzer-common.h"
+
+template <typename T>
+void invoke_fmt(const uint8_t* data, size_t size, unsigned arg_name_size) {
+  static_assert(sizeof(T) <= fixed_size, "fixed_size too small");
+  if (size <= fixed_size) return;
+  const T value = assign_from_buf<T>(data);
+  data += fixed_size;
+  size -= fixed_size;
+
+  if (arg_name_size <= 0 || arg_name_size >= size) return;
+  data_to_string arg_name(data, arg_name_size, true);
+  data += arg_name_size;
+  size -= arg_name_size;
+
+  data_to_string format_str(data, size);
+  try {
+#if FMT_FUZZ_FORMAT_TO_STRING
+    std::string message =
+        fmt::format(format_str.get(), fmt::arg(arg_name.data(), value));
+#else
+    fmt::memory_buffer out;
+    fmt::format_to(std::back_inserter(out), format_str.get(),
+                   fmt::arg(arg_name.data(), value));
+#endif
+  } catch (std::exception&) {
+  }
+}
+
+// For dynamic dispatching to an explicit instantiation.
+template <typename Callback> void invoke(int type, Callback callback) {
+  switch (type) {
+  case 0:
+    callback(bool());
+    break;
+  case 1:
+    callback(char());
+    break;
+  case 2:
+    using sc = signed char;
+    callback(sc());
+    break;
+  case 3:
+    using uc = unsigned char;
+    callback(uc());
+    break;
+  case 4:
+    callback(short());
+    break;
+  case 5:
+    using us = unsigned short;
+    callback(us());
+    break;
+  case 6:
+    callback(int());
+    break;
+  case 7:
+    callback(unsigned());
+    break;
+  case 8:
+    callback(long());
+    break;
+  case 9:
+    using ul = unsigned long;
+    callback(ul());
+    break;
+  case 10:
+    callback(float());
+    break;
+  case 11:
+    callback(double());
+    break;
+  case 12:
+    using LD = long double;
+    callback(LD());
+    break;
+  }
+}
+
+extern "C" int LLVMFuzzerTestOneInput(const uint8_t* data, size_t size) {
+  if (size <= 3) return 0;
+
+  // Switch types depending on the first byte of the input.
+  const auto type = data[0] & 0x0F;
+  const unsigned arg_name_size = (data[0] & 0xF0) >> 4;
+  data++;
+  size--;
+
+  invoke(type, [=](auto arg) {
+    invoke_fmt<decltype(arg)>(data, size, arg_name_size);
+  });
+  return 0;
+}
diff --git a/external/fmt/test/fuzzing/one-arg.cc b/external/fmt/test/fuzzing/one-arg.cc
new file mode 100644
index 00000000..90cec716
--- /dev/null
+++ b/external/fmt/test/fuzzing/one-arg.cc
@@ -0,0 +1,92 @@
+// Copyright (c) 2019, Paul Dreik
+// For the license information refer to format.h.
+
+#include <fmt/chrono.h>
+
+#include <cstdint>
+#include <exception>
+
+#include "fuzzer-common.h"
+
+template <typename T, typename Repr> const T* from_repr(const Repr& r) {
+  return &r;
+}
+
+template <> const std::tm* from_repr<std::tm>(const std::time_t& t) {
+  return std::localtime(&t);
+}
+
+template <typename T, typename Repr = T>
+void invoke_fmt(const uint8_t* data, size_t size) {
+  static_assert(sizeof(Repr) <= fixed_size, "Nfixed is too small");
+  if (size <= fixed_size) return;
+  auto repr = assign_from_buf<Repr>(data);
+  const T* value = from_repr<T>(repr);
+  if (!value) return;
+  data += fixed_size;
+  size -= fixed_size;
+  data_to_string format_str(data, size);
+  try {
+#if FMT_FUZZ_FORMAT_TO_STRING
+    std::string message = fmt::format(format_str.get(), *value);
+#else
+    fmt::memory_buffer message;
+    fmt::format_to(message, format_str.get(), *value);
+#endif
+  } catch (std::exception&) {
+  }
+}
+
+extern "C" int LLVMFuzzerTestOneInput(const uint8_t* data, size_t size) {
+  if (size <= 3) return 0;
+
+  const auto first = data[0];
+  data++;
+  size--;
+
+  switch (first) {
+  case 0:
+    invoke_fmt<bool>(data, size);
+    break;
+  case 1:
+    invoke_fmt<char>(data, size);
+    break;
+  case 2:
+    invoke_fmt<unsigned char>(data, size);
+    break;
+  case 3:
+    invoke_fmt<signed char>(data, size);
+    break;
+  case 4:
+    invoke_fmt<short>(data, size);
+    break;
+  case 5:
+    invoke_fmt<unsigned short>(data, size);
+    break;
+  case 6:
+    invoke_fmt<int>(data, size);
+    break;
+  case 7:
+    invoke_fmt<unsigned int>(data, size);
+    break;
+  case 8:
+    invoke_fmt<long>(data, size);
+    break;
+  case 9:
+    invoke_fmt<unsigned long>(data, size);
+    break;
+  case 10:
+    invoke_fmt<float>(data, size);
+    break;
+  case 11:
+    invoke_fmt<double>(data, size);
+    break;
+  case 12:
+    invoke_fmt<long double>(data, size);
+    break;
+  case 13:
+    invoke_fmt<std::tm, std::time_t>(data, size);
+    break;
+  }
+  return 0;
+}
diff --git a/external/fmt/test/fuzzing/two-args.cc b/external/fmt/test/fuzzing/two-args.cc
new file mode 100644
index 00000000..979320c2
--- /dev/null
+++ b/external/fmt/test/fuzzing/two-args.cc
@@ -0,0 +1,106 @@
+// Copyright (c) 2019, Paul Dreik
+// For the license information refer to format.h.
+
+#include <fmt/format.h>
+
+#include <cstdint>
+#include <exception>
+#include <string>
+
+#include "fuzzer-common.h"
+
+template <typename Item1, typename Item2>
+void invoke_fmt(const uint8_t* data, size_t size) {
+  static_assert(sizeof(Item1) <= fixed_size, "size1 exceeded");
+  static_assert(sizeof(Item2) <= fixed_size, "size2 exceeded");
+  if (size <= fixed_size + fixed_size) return;
+
+  const Item1 item1 = assign_from_buf<Item1>(data);
+  data += fixed_size;
+  size -= fixed_size;
+
+  const Item2 item2 = assign_from_buf<Item2>(data);
+  data += fixed_size;
+  size -= fixed_size;
+
+  auto format_str = fmt::string_view(as_chars(data), size);
+#if FMT_FUZZ_FORMAT_TO_STRING
+  std::string message = fmt::format(format_str, item1, item2);
+#else
+  fmt::memory_buffer message;
+  fmt::format_to(message, format_str, item1, item2);
+#endif
+}
+
+// For dynamic dispatching to an explicit instantiation.
+template <typename Callback> void invoke(int index, Callback callback) {
+  switch (index) {
+  case 0:
+    callback(bool());
+    break;
+  case 1:
+    callback(char());
+    break;
+  case 2:
+    using sc = signed char;
+    callback(sc());
+    break;
+  case 3:
+    using uc = unsigned char;
+    callback(uc());
+    break;
+  case 4:
+    callback(short());
+    break;
+  case 5:
+    using us = unsigned short;
+    callback(us());
+    break;
+  case 6:
+    callback(int());
+    break;
+  case 7:
+    callback(unsigned());
+    break;
+  case 8:
+    callback(long());
+    break;
+  case 9:
+    using ul = unsigned long;
+    callback(ul());
+    break;
+  case 10:
+    callback(float());
+    break;
+  case 11:
+    callback(double());
+    break;
+  case 12:
+    using LD = long double;
+    callback(LD());
+    break;
+  case 13:
+    using ptr = void*;
+    callback(ptr());
+    break;
+  }
+}
+
+extern "C" int LLVMFuzzerTestOneInput(const uint8_t* data, size_t size) {
+  if (size <= 3) return 0;
+
+  // Switch types depending on the first byte of the input.
+  const auto type1 = data[0] & 0x0F;
+  const auto type2 = (data[0] & 0xF0) >> 4;
+  data++;
+  size--;
+  try {
+    invoke(type1, [=](auto param1) {
+      invoke(type2, [=](auto param2) {
+        invoke_fmt<decltype(param1), decltype(param2)>(data, size);
+      });
+    });
+  } catch (std::exception&) {
+  }
+  return 0;
+}
diff --git a/external/fmt/test/gtest-extra-test.cc b/external/fmt/test/gtest-extra-test.cc
index ea728607..0d86206c 100644
--- a/external/fmt/test/gtest-extra-test.cc
+++ b/external/fmt/test/gtest-extra-test.cc
@@ -9,31 +9,18 @@
 
 #include <gtest/gtest-spi.h>
 
-#include <algorithm>
 #include <cstring>
 #include <memory>
 #include <stdexcept>
 
-#if defined(_WIN32) && !defined(__MINGW32__)
-#  include <crtdbg.h>  // for _CrtSetReportMode
-#endif                 // _WIN32
-
+#include "fmt/os.h"
 #include "util.h"
 
-namespace {
-
-// This is used to suppress coverity warnings about untrusted values.
-std::string sanitize(const std::string& s) {
-  std::string result;
-  for (std::string::const_iterator i = s.begin(), end = s.end(); i != end; ++i)
-    result.push_back(static_cast<char>(*i & 0xff));
-  return result;
-}
-
 // Tests that assertion macros evaluate their arguments exactly once.
-class SingleEvaluationTest : public ::testing::Test {
+namespace {
+class single_evaluation_test : public ::testing::Test {
  protected:
-  SingleEvaluationTest() {
+  single_evaluation_test() {
     p_ = s_;
     a_ = 0;
     b_ = 0;
@@ -45,11 +32,12 @@ class SingleEvaluationTest : public ::testing::Test {
   static int a_;
   static int b_;
 };
+}  // namespace
 
-const char* const SingleEvaluationTest::s_ = "01234";
-const char* SingleEvaluationTest::p_;
-int SingleEvaluationTest::a_;
-int SingleEvaluationTest::b_;
+const char* const single_evaluation_test::s_ = "01234";
+const char* single_evaluation_test::p_;
+int single_evaluation_test::a_;
+int single_evaluation_test::b_;
 
 void do_nothing() {}
 
@@ -61,7 +49,7 @@ FMT_NORETURN void throw_system_error() {
 
 // Tests that when EXPECT_THROW_MSG fails, it evaluates its message argument
 // exactly once.
-TEST_F(SingleEvaluationTest, FailedEXPECT_THROW_MSG) {
+TEST_F(single_evaluation_test, failed_expect_throw_msg) {
   EXPECT_NONFATAL_FAILURE(
       EXPECT_THROW_MSG(throw_exception(), std::exception, p_++), "01234");
   EXPECT_EQ(s_ + 1, p_);
@@ -69,14 +57,14 @@ TEST_F(SingleEvaluationTest, FailedEXPECT_THROW_MSG) {
 
 // Tests that when EXPECT_SYSTEM_ERROR fails, it evaluates its message argument
 // exactly once.
-TEST_F(SingleEvaluationTest, FailedEXPECT_SYSTEM_ERROR) {
+TEST_F(single_evaluation_test, failed_expect_system_error) {
   EXPECT_NONFATAL_FAILURE(EXPECT_SYSTEM_ERROR(throw_system_error(), EDOM, p_++),
                           "01234");
   EXPECT_EQ(s_ + 1, p_);
 }
 
 // Tests that assertion arguments are evaluated exactly once.
-TEST_F(SingleEvaluationTest, ExceptionTests) {
+TEST_F(single_evaluation_test, exception_tests) {
   // successful EXPECT_THROW_MSG
   EXPECT_THROW_MSG(
       {  // NOLINT
@@ -116,7 +104,7 @@ TEST_F(SingleEvaluationTest, ExceptionTests) {
   EXPECT_EQ(4, b_);
 }
 
-TEST_F(SingleEvaluationTest, SystemErrorTests) {
+TEST_F(single_evaluation_test, system_error_tests) {
   // successful EXPECT_SYSTEM_ERROR
   EXPECT_SYSTEM_ERROR(
       {  // NOLINT
@@ -159,14 +147,14 @@ TEST_F(SingleEvaluationTest, SystemErrorTests) {
 #if FMT_USE_FCNTL
 // Tests that when EXPECT_WRITE fails, it evaluates its message argument
 // exactly once.
-TEST_F(SingleEvaluationTest, FailedEXPECT_WRITE) {
+TEST_F(single_evaluation_test, failed_expect_write) {
   EXPECT_NONFATAL_FAILURE(EXPECT_WRITE(stdout, std::printf("test"), p_++),
                           "01234");
   EXPECT_EQ(s_ + 1, p_);
 }
 
 // Tests that assertion arguments are evaluated exactly once.
-TEST_F(SingleEvaluationTest, WriteTests) {
+TEST_F(single_evaluation_test, write_tests) {
   // successful EXPECT_WRITE
   EXPECT_WRITE(
       stdout,
@@ -192,7 +180,7 @@ TEST_F(SingleEvaluationTest, WriteTests) {
 }
 
 // Tests EXPECT_WRITE.
-TEST(ExpectTest, EXPECT_WRITE) {
+TEST(gtest_extra_test, expect_write) {
   EXPECT_WRITE(stdout, do_nothing(), "");
   EXPECT_WRITE(stdout, std::printf("test"), "test");
   EXPECT_WRITE(stderr, std::fprintf(stderr, "test"), "test");
@@ -201,7 +189,7 @@ TEST(ExpectTest, EXPECT_WRITE) {
                           "  Actual: that");
 }
 
-TEST(StreamingAssertionsTest, EXPECT_WRITE) {
+TEST(gtest_extra_test, expect_write_streaming) {
   EXPECT_WRITE(stdout, std::printf("test"), "test") << "unexpected failure";
   EXPECT_NONFATAL_FAILURE(EXPECT_WRITE(stdout, std::printf("test"), "other")
                               << "expected failure",
@@ -211,7 +199,7 @@ TEST(StreamingAssertionsTest, EXPECT_WRITE) {
 
 // Tests that the compiler will not complain about unreachable code in the
 // EXPECT_THROW_MSG macro.
-TEST(ExpectThrowTest, DoesNotGenerateUnreachableCodeWarning) {
+TEST(gtest_extra_test, expect_throw_no_unreachable_code_warning) {
   int n = 0;
   using std::runtime_error;
   EXPECT_THROW_MSG(throw runtime_error(""), runtime_error, "");
@@ -223,7 +211,7 @@ TEST(ExpectThrowTest, DoesNotGenerateUnreachableCodeWarning) {
 
 // Tests that the compiler will not complain about unreachable code in the
 // EXPECT_SYSTEM_ERROR macro.
-TEST(ExpectSystemErrorTest, DoesNotGenerateUnreachableCodeWarning) {
+TEST(gtest_extra_test, expect_system_error_no_unreachable_code_warning) {
   int n = 0;
   EXPECT_SYSTEM_ERROR(throw fmt::system_error(EDOM, "test"), EDOM, "test");
   EXPECT_NONFATAL_FAILURE(EXPECT_SYSTEM_ERROR(n++, EDOM, ""), "");
@@ -233,7 +221,7 @@ TEST(ExpectSystemErrorTest, DoesNotGenerateUnreachableCodeWarning) {
       "");
 }
 
-TEST(AssertionSyntaxTest, ExceptionAssertionBehavesLikeSingleStatement) {
+TEST(gtest_extra_test, expect_throw_behaves_like_single_statement) {
   if (::testing::internal::AlwaysFalse())
     EXPECT_THROW_MSG(do_nothing(), std::exception, "");
 
@@ -243,7 +231,7 @@ TEST(AssertionSyntaxTest, ExceptionAssertionBehavesLikeSingleStatement) {
     do_nothing();
 }
 
-TEST(AssertionSyntaxTest, SystemErrorAssertionBehavesLikeSingleStatement) {
+TEST(gtest_extra_test, expect_system_error_behaves_like_single_statement) {
   if (::testing::internal::AlwaysFalse())
     EXPECT_SYSTEM_ERROR(do_nothing(), EDOM, "");
 
@@ -253,7 +241,7 @@ TEST(AssertionSyntaxTest, SystemErrorAssertionBehavesLikeSingleStatement) {
     do_nothing();
 }
 
-TEST(AssertionSyntaxTest, WriteAssertionBehavesLikeSingleStatement) {
+TEST(gtest_extra_test, expect_write_behaves_like_single_statement) {
   if (::testing::internal::AlwaysFalse())
     EXPECT_WRITE(stdout, std::printf("x"), "x");
 
@@ -264,7 +252,7 @@ TEST(AssertionSyntaxTest, WriteAssertionBehavesLikeSingleStatement) {
 }
 
 // Tests EXPECT_THROW_MSG.
-TEST(ExpectTest, EXPECT_THROW_MSG) {
+TEST(gtest_extra_test, expect_throw_msg) {
   EXPECT_THROW_MSG(throw_exception(), std::exception, "test");
   EXPECT_NONFATAL_FAILURE(
       EXPECT_THROW_MSG(throw_exception(), std::logic_error, "test"),
@@ -282,15 +270,15 @@ TEST(ExpectTest, EXPECT_THROW_MSG) {
 }
 
 // Tests EXPECT_SYSTEM_ERROR.
-TEST(ExpectTest, EXPECT_SYSTEM_ERROR) {
+TEST(gtest_extra_test, expect_system_error) {
   EXPECT_SYSTEM_ERROR(throw_system_error(), EDOM, "test");
   EXPECT_NONFATAL_FAILURE(
       EXPECT_SYSTEM_ERROR(throw_exception(), EDOM, "test"),
       "Expected: throw_exception() throws an exception of "
-      "type fmt::system_error.\n  Actual: it throws a different type.");
+      "type std::system_error.\n  Actual: it throws a different type.");
   EXPECT_NONFATAL_FAILURE(
       EXPECT_SYSTEM_ERROR(do_nothing(), EDOM, "test"),
-      "Expected: do_nothing() throws an exception of type fmt::system_error.\n"
+      "Expected: do_nothing() throws an exception of type std::system_error.\n"
       "  Actual: it throws nothing.");
   EXPECT_NONFATAL_FAILURE(
       EXPECT_SYSTEM_ERROR(throw_system_error(), EDOM, "other"),
@@ -298,11 +286,11 @@ TEST(ExpectTest, EXPECT_SYSTEM_ERROR) {
           "throw_system_error() throws an exception with a different message.\n"
           "Expected: {}\n"
           "  Actual: {}",
-          format_system_error(EDOM, "other"),
-          format_system_error(EDOM, "test")));
+          system_error_message(EDOM, "other"),
+          system_error_message(EDOM, "test")));
 }
 
-TEST(StreamingAssertionsTest, EXPECT_THROW_MSG) {
+TEST(gtest_extra_test, expect_throw_msg_streaming) {
   EXPECT_THROW_MSG(throw_exception(), std::exception, "test")
       << "unexpected failure";
   EXPECT_NONFATAL_FAILURE(
@@ -311,7 +299,7 @@ TEST(StreamingAssertionsTest, EXPECT_THROW_MSG) {
       "expected failure");
 }
 
-TEST(StreamingAssertionsTest, EXPECT_SYSTEM_ERROR) {
+TEST(gtest_extra_test, expect_system_error_streaming) {
   EXPECT_SYSTEM_ERROR(throw_system_error(), EDOM, "test")
       << "unexpected failure";
   EXPECT_NONFATAL_FAILURE(
@@ -320,31 +308,19 @@ TEST(StreamingAssertionsTest, EXPECT_SYSTEM_ERROR) {
       "expected failure");
 }
 
-TEST(UtilTest, FormatSystemError) {
-  fmt::memory_buffer out;
-  fmt::format_system_error(out, EDOM, "test message");
-  EXPECT_EQ(to_string(out), format_system_error(EDOM, "test message"));
-}
-
 #if FMT_USE_FCNTL
 
 using fmt::buffered_file;
-using fmt::error_code;
 using fmt::file;
 
-TEST(ErrorCodeTest, Ctor) {
-  EXPECT_EQ(error_code().get(), 0);
-  EXPECT_EQ(error_code(42).get(), 42);
-}
-
-TEST(OutputRedirectTest, ScopedRedirect) {
+TEST(output_redirect_test, scoped_redirect) {
   file read_end, write_end;
   file::pipe(read_end, write_end);
   {
     buffered_file file(write_end.fdopen("w"));
     std::fprintf(file.get(), "[[[");
     {
-      OutputRedirect redir(file.get());
+      output_redirect redir(file.get());
       std::fprintf(file.get(), "censored");
     }
     std::fprintf(file.get(), "]]]");
@@ -352,8 +328,8 @@ TEST(OutputRedirectTest, ScopedRedirect) {
   EXPECT_READ(read_end, "[[[]]]");
 }
 
-// Test that OutputRedirect handles errors in flush correctly.
-TEST(OutputRedirectTest, FlushErrorInCtor) {
+// Test that output_redirect handles errors in flush correctly.
+TEST(output_redirect_test, flush_error_in_ctor) {
   file read_end, write_end;
   file::pipe(read_end, write_end);
   int write_fd = write_end.descriptor();
@@ -362,47 +338,47 @@ TEST(OutputRedirectTest, FlushErrorInCtor) {
   // Put a character in a file buffer.
   EXPECT_EQ('x', fputc('x', f.get()));
   FMT_POSIX(close(write_fd));
-  std::unique_ptr<OutputRedirect> redir{nullptr};
-  EXPECT_SYSTEM_ERROR_NOASSERT(redir.reset(new OutputRedirect(f.get())), EBADF,
+  std::unique_ptr<output_redirect> redir{nullptr};
+  EXPECT_SYSTEM_ERROR_NOASSERT(redir.reset(new output_redirect(f.get())), EBADF,
                                "cannot flush stream");
   redir.reset(nullptr);
   write_copy.dup2(write_fd);  // "undo" close or dtor will fail
 }
 
-TEST(OutputRedirectTest, DupErrorInCtor) {
+TEST(output_redirect_test, dup_error_in_ctor) {
   buffered_file f = open_buffered_file();
   int fd = (f.fileno)();
   file copy = file::dup(fd);
   FMT_POSIX(close(fd));
-  std::unique_ptr<OutputRedirect> redir{nullptr};
+  std::unique_ptr<output_redirect> redir{nullptr};
   EXPECT_SYSTEM_ERROR_NOASSERT(
-      redir.reset(new OutputRedirect(f.get())), EBADF,
+      redir.reset(new output_redirect(f.get())), EBADF,
       fmt::format("cannot duplicate file descriptor {}", fd));
   copy.dup2(fd);  // "undo" close or dtor will fail
 }
 
-TEST(OutputRedirectTest, RestoreAndRead) {
+TEST(output_redirect_test, restore_and_read) {
   file read_end, write_end;
   file::pipe(read_end, write_end);
   buffered_file file(write_end.fdopen("w"));
   std::fprintf(file.get(), "[[[");
-  OutputRedirect redir(file.get());
+  output_redirect redir(file.get());
   std::fprintf(file.get(), "censored");
-  EXPECT_EQ("censored", sanitize(redir.restore_and_read()));
-  EXPECT_EQ("", sanitize(redir.restore_and_read()));
+  EXPECT_EQ("censored", redir.restore_and_read());
+  EXPECT_EQ("", redir.restore_and_read());
   std::fprintf(file.get(), "]]]");
   file = buffered_file();
   EXPECT_READ(read_end, "[[[]]]");
 }
 
 // Test that OutputRedirect handles errors in flush correctly.
-TEST(OutputRedirectTest, FlushErrorInRestoreAndRead) {
+TEST(output_redirect_test, flush_error_in_restore_and_read) {
   file read_end, write_end;
   file::pipe(read_end, write_end);
   int write_fd = write_end.descriptor();
   file write_copy = write_end.dup(write_fd);
   buffered_file f = write_end.fdopen("w");
-  OutputRedirect redir(f.get());
+  output_redirect redir(f.get());
   // Put a character in a file buffer.
   EXPECT_EQ('x', fputc('x', f.get()));
   FMT_POSIX(close(write_fd));
@@ -411,13 +387,13 @@ TEST(OutputRedirectTest, FlushErrorInRestoreAndRead) {
   write_copy.dup2(write_fd);  // "undo" close or dtor will fail
 }
 
-TEST(OutputRedirectTest, ErrorInDtor) {
+TEST(output_redirect_test, error_in_dtor) {
   file read_end, write_end;
   file::pipe(read_end, write_end);
   int write_fd = write_end.descriptor();
   file write_copy = write_end.dup(write_fd);
   buffered_file f = write_end.fdopen("w");
-  std::unique_ptr<OutputRedirect> redir(new OutputRedirect(f.get()));
+  std::unique_ptr<output_redirect> redir(new output_redirect(f.get()));
   // Put a character in a file buffer.
   EXPECT_EQ('x', fputc('x', f.get()));
   EXPECT_WRITE(
@@ -430,10 +406,8 @@ TEST(OutputRedirectTest, ErrorInDtor) {
         FMT_POSIX(close(write_fd));
         SUPPRESS_ASSERT(redir.reset(nullptr));
       },
-      format_system_error(EBADF, "cannot flush stream"));
+      system_error_message(EBADF, "cannot flush stream"));
   write_copy.dup2(write_fd);  // "undo" close or dtor of buffered_file will fail
 }
 
-#endif  // FMT_USE_FILE_DESCRIPTORS
-
-}  // namespace
+#endif  // FMT_USE_FCNTL
diff --git a/external/fmt/test/gtest-extra.cc b/external/fmt/test/gtest-extra.cc
index 58628a8a..1d48a173 100644
--- a/external/fmt/test/gtest-extra.cc
+++ b/external/fmt/test/gtest-extra.cc
@@ -11,24 +11,7 @@
 
 using fmt::file;
 
-void OutputRedirect::flush() {
-#  if EOF != -1
-#    error "FMT_RETRY assumes return value of -1 indicating failure"
-#  endif
-  int result = 0;
-  FMT_RETRY(result, fflush(file_));
-  if (result != 0) throw fmt::system_error(errno, "cannot flush stream");
-}
-
-void OutputRedirect::restore() {
-  if (original_.descriptor() == -1) return;  // Already restored.
-  flush();
-  // Restore the original file.
-  original_.dup2(FMT_POSIX(fileno(file_)));
-  original_.close();
-}
-
-OutputRedirect::OutputRedirect(FILE* f) : file_(f) {
+output_redirect::output_redirect(FILE* f) : file_(f) {
   flush();
   int fd = FMT_POSIX(fileno(f));
   // Create a file object referring to the original file.
@@ -40,7 +23,7 @@ OutputRedirect::OutputRedirect(FILE* f) : file_(f) {
   write_end.dup2(fd);
 }
 
-OutputRedirect::~OutputRedirect() FMT_NOEXCEPT {
+output_redirect::~output_redirect() FMT_NOEXCEPT {
   try {
     restore();
   } catch (const std::exception& e) {
@@ -48,7 +31,23 @@ OutputRedirect::~OutputRedirect() FMT_NOEXCEPT {
   }
 }
 
-std::string OutputRedirect::restore_and_read() {
+void output_redirect::flush() {
+  int result = 0;
+  do {
+    result = fflush(file_);
+  } while (result == EOF && errno == EINTR);
+  if (result != 0) throw fmt::system_error(errno, "cannot flush stream");
+}
+
+void output_redirect::restore() {
+  if (original_.descriptor() == -1) return;  // Already restored.
+  flush();
+  // Restore the original file.
+  original_.dup2(FMT_POSIX(fileno(file_)));
+  original_.close();
+}
+
+std::string output_redirect::restore_and_read() {
   // Restore output.
   restore();
 
@@ -79,9 +78,3 @@ std::string read(file& f, size_t count) {
 }
 
 #endif  // FMT_USE_FCNTL
-
-std::string format_system_error(int error_code, fmt::string_view message) {
-  fmt::memory_buffer out;
-  format_system_error(out, error_code, message);
-  return to_string(out);
-}
diff --git a/external/fmt/test/gtest-extra.h b/external/fmt/test/gtest-extra.h
index 3ed8052b..df2b1d8c 100644
--- a/external/fmt/test/gtest-extra.h
+++ b/external/fmt/test/gtest-extra.h
@@ -8,10 +8,17 @@
 #ifndef FMT_GTEST_EXTRA_H_
 #define FMT_GTEST_EXTRA_H_
 
+#include <stdlib.h>  // _invalid_parameter_handler
+
 #include <string>
 
-#include "fmt/os.h"
-#include "gmock.h"
+#ifdef FMT_MODULE_TEST
+import fmt;
+#else
+#  include "fmt/os.h"
+#endif  // FMG_MODULE_TEST
+
+#include "gmock/gmock.h"
 
 #define FMT_TEST_THROW_(statement, expected_exception, expected_message, fail) \
   GTEST_AMBIGUOUS_ELSE_BLOCKER_                                                \
@@ -51,30 +58,35 @@
   FMT_TEST_THROW_(statement, expected_exception, expected_message,        \
                   GTEST_NONFATAL_FAILURE_)
 
-std::string format_system_error(int error_code, fmt::string_view message);
+inline std::string system_error_message(int error_code,
+                                        const std::string& message) {
+  auto ec = std::error_code(error_code, std::generic_category());
+  return std::system_error(ec, message).what();
+}
 
 #define EXPECT_SYSTEM_ERROR(statement, error_code, message) \
-  EXPECT_THROW_MSG(statement, fmt::system_error,            \
-                   format_system_error(error_code, message))
+  EXPECT_THROW_MSG(statement, std::system_error,            \
+                   system_error_message(error_code, message))
 
 #if FMT_USE_FCNTL
 
 // Captures file output by redirecting it to a pipe.
 // The output it can handle is limited by the pipe capacity.
-class OutputRedirect {
+class output_redirect {
  private:
   FILE* file_;
   fmt::file original_;  // Original file passed to redirector.
   fmt::file read_end_;  // Read end of the pipe where the output is redirected.
 
-  GTEST_DISALLOW_COPY_AND_ASSIGN_(OutputRedirect);
-
   void flush();
   void restore();
 
  public:
-  explicit OutputRedirect(FILE* file);
-  ~OutputRedirect() FMT_NOEXCEPT;
+  explicit output_redirect(FILE* file);
+  ~output_redirect() FMT_NOEXCEPT;
+
+  output_redirect(const output_redirect&) = delete;
+  void operator=(const output_redirect&) = delete;
 
   // Restores the original file, reads output from the pipe into a string
   // and returns it.
@@ -85,7 +97,7 @@ class OutputRedirect {
     GTEST_AMBIGUOUS_ELSE_BLOCKER_                                              \
     if (::testing::AssertionResult gtest_ar = ::testing::AssertionSuccess()) { \
       std::string gtest_expected_output = expected_output;                     \
-      OutputRedirect gtest_redir(file);                                        \
+      output_redirect gtest_redir(file);                                       \
       GTEST_SUPPRESS_UNREACHABLE_CODE_WARNING_BELOW_(statement);               \
       std::string gtest_output = gtest_redir.restore_and_read();               \
       if (gtest_output != gtest_expected_output) {                             \
@@ -106,7 +118,7 @@ class OutputRedirect {
 
 // Suppresses Windows assertions on invalid file descriptors, making
 // POSIX functions return proper error codes instead of crashing on Windows.
-class SuppressAssert {
+class suppress_assert {
  private:
   _invalid_parameter_handler original_handler_;
   int original_report_mode_;
@@ -115,19 +127,20 @@ class SuppressAssert {
                                        const wchar_t*, unsigned, uintptr_t) {}
 
  public:
-  SuppressAssert()
+  suppress_assert()
       : original_handler_(
             _set_invalid_parameter_handler(handle_invalid_parameter)),
         original_report_mode_(_CrtSetReportMode(_CRT_ASSERT, 0)) {}
-  ~SuppressAssert() {
+  ~suppress_assert() {
     _set_invalid_parameter_handler(original_handler_);
     _CrtSetReportMode(_CRT_ASSERT, original_report_mode_);
+    (void)original_report_mode_;
   }
 };
 
 #    define SUPPRESS_ASSERT(statement) \
       {                                \
-        SuppressAssert sa;             \
+        suppress_assert sa;            \
         statement;                     \
       }
 #  else
@@ -141,16 +154,17 @@ class SuppressAssert {
 std::string read(fmt::file& f, size_t count);
 
 #  define EXPECT_READ(file, expected_content) \
-    EXPECT_EQ(expected_content, \
+    EXPECT_EQ(expected_content,               \
               read(file, fmt::string_view(expected_content).size()))
 
 #else
-#  define EXPECT_WRITE(file, statement, expected_output) SUCCEED()
+#  define EXPECT_WRITE(file, statement, expected_output) \
+    do {                                                 \
+      (void)(file);                                      \
+      (void)(statement);                                 \
+      (void)(expected_output);                           \
+      SUCCEED();                                         \
+    } while (false)
 #endif  // FMT_USE_FCNTL
 
-template <typename Mock> struct ScopedMock : testing::StrictMock<Mock> {
-  ScopedMock() { Mock::instance = this; }
-  ~ScopedMock() { Mock::instance = nullptr; }
-};
-
 #endif  // FMT_GTEST_EXTRA_H_
